<template>
  <v-tooltip
    :left="tooltipDirection === 'left'"
    :right="tooltipDirection === 'right'"
    :top="tooltipDirection === 'top'"
    :bottom="tooltipDirection === 'bottom'"
    :disabled="!tooltip"
  >
    <template #activator="{ on, attrs }">
      <v-btn
        :id="btnId"
        class="fab v-btn--round"
        v-bind="{ ...attrs, ...attrsParent}"
        elevation="2"
        bottom
        right
        :color="color"
        :disabled="disabled"
        v-on="on"
        @click="click"
      >
        <v-icon v-text="icon" />
        <div v-if="chip" class="btn-chip" :class="{ 'disabled': disabled }">
          {{ chip }}
        </div>
      </v-btn>
    </template>
    {{ tooltip }}
  </v-tooltip>
</template>
<script lang="ts">
import { defineComponent } from 'vue';

export default defineComponent({
  inheritAttrs: false,
  props: {
    color: {
      required: false,
      type: String,
      default: null,
    },
    tooltip: {
      type: String,
      default: null,
    },
    tooltipDirection: {
      default: 'top',
      type: String,
    },
    icon: {
      type: String,
      default: null,
    },
    disabled: {
      type: Boolean,
    },
    btnId: {
      required: false,
      default: null,
      type: String,
    },
    chip: { required: false, default: null, type: String },
  },
  data() {
    return {
      attrsParent: this.$attrs,
    };
  },
  methods: {
    click(e: MouseEvent) {
      this.$emit('click', e);
    },
  },
});

</script>
<style scoped lang="scss">
.fab {
  margin: 5px;
  height: 56px;
  width: 56px;
  .btn-chip {
    &.disabled {
      background: #ccc;
      color: #777;
    }

    background: #777;
    color: white;
    text-align: center;
    position: absolute;
    top: 23px;
    left: 32px;
    width: 20px;
    height: 20px;
    border-radius: 20px;
    display: flex;
    align-items: center;
    justify-content: center;
    text-transform: none;
  }
}
</style>
